## pgagroal 2.0.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14.0)

set(VERSION_MAJOR "2")
set(VERSION_MINOR "0")
set(VERSION_PATCH "1")
set(VERSION_STRING ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})

#
# Avoid source tree pollution
#
set(CMAKE_DISABLE_SOURCE_CHANGES ON)
set(CMAKE_DISABLE_IN_SOURCE_BUILD ON)

If(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
  message(FATAL_ERROR "In-source builds are not permitted. Make a separate folder for building:\nmkdir build; cd build; cmake ..\nBefore that, remove the files already created:\nrm -rf CMakeCache.txt CMakeFiles")
endif(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)

project(pgagroal VERSION ${VERSION_STRING} LANGUAGES  C)

if (NOT DEFINED DOCS)
  set(DOCS TRUE)
endif()
include(CTest)
enable_testing()

set(CPACK_PACKAGE_VERSION_MAJOR ${VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${VERSION_PATCH})
set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_SOURCE_PACKAGE_FILE_NAME
  "${CMAKE_PROJECT_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
set(CPACK_SOURCE_IGNORE_FILES
  "/build/;/test/;/.cache/;/.git/;/.github/;/*.patch;/.bundle/;/_site/;/vendor/;~$;${CPACK_SOURCE_IGNORE_FILES}")
set(CPACK_PACKAGE_CHECKSUM "SHA256")
include(CPack)

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

message(STATUS "pgagroal ${VERSION_STRING}")

set(check TRUE)
set(container FALSE)

include(CheckCCompilerFlag)
include(CheckCSourceCompiles)
include(CheckIncludeFile)
include(CheckLinkerFlag)
include(CheckFunctionExists)
include(FindPackageHandleStandardArgs)
include(GNUInstallDirs)

if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: Debug Release Performance" FORCE)
endif ()

message(STATUS "Build type is ${CMAKE_BUILD_TYPE}")
message(STATUS "System is ${CMAKE_SYSTEM_NAME}")

set(SUPPORTED_COMPILERS "GNU" "Clang" "AppleClang")

# Check for a supported compiler
if (NOT CMAKE_C_COMPILER_ID IN_LIST SUPPORTED_COMPILERS)
  message(FATAL_ERROR "Unsupported compiler ${CMAKE_C_COMPILER_ID}. Supported compilers are: ${SUPPORTED_COMPILERS}")
endif ()

CHECK_C_COMPILER_FLAG("-std=c17" COMPILER_SUPPORTS_C17)
if(NOT COMPILER_SUPPORTS_C17)
  message(FATAL_ERROR "The compiler ${CMAKE_C_COMPILER} has no C17 support. Please use a different C compiler.")
endif()

find_package(Check)
if (CHECK_FOUND)
  message(STATUS "check found")
  add_library(Check::check SHARED IMPORTED)
  set_target_properties(Check::check PROPERTIES
    IMPORTED_LOCATION ${CHECK_LIBRARY}
    INTERFACE_INCLUDE_DIRECTORIES ${CHECK_INCLUDE_DIR})
else ()
  message(STATUS "check needed. The testsuite process will be skipped.")
  set(check FALSE)
endif()

find_program(DOCKER_EXECUTABLE docker)
find_program(PODMAN_EXECUTABLE podman)
if (DOCKER_EXECUTABLE OR PODMAN_EXECUTABLE)
  set(container TRUE)
  message(STATUS "Docker or podman found")
else ()
  message(STATUS "Docker or podman needed. The test suite will be skipped.")
endif()


find_package(ZLIB)
if (ZLIB_FOUND)
  message(STATUS "zlib found")
else ()
  message(FATAL_ERROR "zlib needed")
endif()

find_package(BZip2)
if (BZIP2_FOUND)
  message(STATUS "bzip2 found")
else ()
  message(FATAL_ERROR "bzip2 needed")
endif()

find_package(Zstd)
if (ZSTD_FOUND)
  message(STATUS "zstd found")
else ()
  message(FATAL_ERROR "zstd needed")
endif()

find_package(Lz4)
if (LZ4_FOUND)
  message(STATUS "lz4 found")
else ()
  message(FATAL_ERROR "lz4 needed")
endif()

find_package(OpenSSL)
if (OPENSSL_FOUND)
  message(STATUS "OpenSSL found")
else ()
  message(FATAL_ERROR "OpenSSL needed")
endif()

find_package(Rst2man)
if (RST2MAN_FOUND)
  message(STATUS "rst2man found")
else ()
  message(FATAL_ERROR "rst2man needed")
endif()

find_package(THREAD)
if (THREAD_FOUND)
  message(STATUS "pthread found")
else ()
  message(FATAL_ERROR "pthread needed")
endif()

if (DOCS)
  find_package(Pandoc)
  if (PANDOC_FOUND)
    message(STATUS "pandoc found")
  else ()
    set(DOCS FALSE)
    message(STATUS "pandoc needed. The documentation will be skipped.")
  endif()

  find_package(Pdflatex)
  if (PDFLATEX_FOUND)
    message(STATUS "pdflatex found")
  else ()
    set(DOCS FALSE)
    message(STATUS "pdflatex needed. The documentation will be skipped.")
  endif()
endif()

find_package(Doxygen)

if (DOXYGEN_FOUND)
  message(status "Doxygen found: ${DOXYGEN_EXECUTABLE}")
endif()

if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
  find_package(Libatomic)
  if (LIBATOMIC_FOUND)
    message(STATUS "libatomic found")
  else ()
    message(FATAL_ERROR "libatomic needed")
  endif()

  find_package(Liburing 2.5)
  if (LIBURING_FOUND)
    message(STATUS "liburing found")
  else()
    message(FATAL_ERROR "liburing needed")
  endif()

  find_package(Systemd)
  if (SYSTEMD_FOUND)
    message(STATUS "systemd found")
  else ()
  message(STATUS "systemd not found; building without systemd support")
  endif()

  check_function_exists(epoll_pwait2 HAVE_EPOLL_PWAIT2)
endif()

file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/src/")

add_subdirectory(doc)
add_subdirectory(src)
if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/test")
  add_subdirectory(test)
else()
  message(STATUS "Test directory not found, skipping tests")
endif()

=== doc/CMakeLists.txt ===
if (RST2MAN_FOUND)
  # man target
  add_custom_target(man ALL)

  # man page definitions
  set(PGAGROAL_SRC_FILE "${CMAKE_CURRENT_SOURCE_DIR}/man/pgagroal.1.rst")
  set(PGAGROAL_DST_FILE "${CMAKE_CURRENT_BINARY_DIR}/pgagroal.1")
  set(PGAGROAL_CLI_SRC_FILE "${CMAKE_CURRENT_SOURCE_DIR}/man/pgagroal-cli.1.rst")
  set(PGAGROAL_CLI_DST_FILE "${CMAKE_CURRENT_BINARY_DIR}/pgagroal-cli.1")
  set(PGAGROAL_ADMIN_SRC_FILE "${CMAKE_CURRENT_SOURCE_DIR}/man/pgagroal-admin.1.rst")
  set(PGAGROAL_ADMIN_DST_FILE "${CMAKE_CURRENT_BINARY_DIR}/pgagroal-admin.1")
  set(PGAGROAL_CONF_SRC_FILE "${CMAKE_CURRENT_SOURCE_DIR}/man/pgagroal.conf.5.rst")
  set(PGAGROAL_CONF_DST_FILE "${CMAKE_CURRENT_BINARY_DIR}/pgagroal.conf.5")
  set(PGAGROAL_HBA_CONF_SRC_FILE "${CMAKE_CURRENT_SOURCE_DIR}/man/pgagroal_hba.conf.5.rst")
  set(PGAGROAL_HBA_CONF_DST_FILE "${CMAKE_CURRENT_BINARY_DIR}/pgagroal_hba.conf.5")
  set(PGAGROAL_DATABASES_CONF_SRC_FILE "${CMAKE_CURRENT_SOURCE_DIR}/man/pgagroal_databases.conf.5.rst")
  set(PGAGROAL_DATABASES_CONF_DST_FILE "${CMAKE_CURRENT_BINARY_DIR}/pgagroal_databases.conf.5")
  set(PGAGROAL_VAULT_SRC_FILE "${CMAKE_CURRENT_SOURCE_DIR}/man/pgagroal-vault.1.rst")
  set(PGAGROAL_VAULT_DST_FILE "${CMAKE_CURRENT_BINARY_DIR}/pgagroal-vault.1")
  set(PGAGROAL_VAULT_CONF_SRC_FILE "${CMAKE_CURRENT_SOURCE_DIR}/man/pgagroal_vault.conf.5.rst")
  set(PGAGROAL_VAULT_CONF_DST_FILE "${CMAKE_CURRENT_BINARY_DIR}/pgagroal_vault.conf.5")

  # pgagroal.1
  add_custom_command(
    OUTPUT ${PGAGROAL_DST_FILE}
    COMMAND ${RST2MAN_EXECUTABLE} ${PGAGROAL_SRC_FILE} ${PGAGROAL_DST_FILE}
    DEPENDS ${PGAGROAL_SRC_FILE}
    COMMENT "Generating man page: pgagroal.1"
  )

  # pgagroal-cli.1
  add_custom_command(
    OUTPUT ${PGAGROAL_CLI_DST_FILE}
    COMMAND ${RST2MAN_EXECUTABLE} ${PGAGROAL_CLI_SRC_FILE} ${PGAGROAL_CLI_DST_FILE}
    DEPENDS ${PGAGROAL_CLI_SRC_FILE}
    COMMENT "Generating man page: pgagroal-cli.1"
  )

  # pgagroal-admin.1
  add_custom_command(
    OUTPUT ${PGAGROAL_ADMIN_DST_FILE}
    COMMAND ${RST2MAN_EXECUTABLE} ${PGAGROAL_ADMIN_SRC_FILE} ${PGAGROAL_ADMIN_DST_FILE}
    DEPENDS ${PGAGROAL_ADMIN_SRC_FILE}
    COMMENT "Generating man page: pgagroal-admin.1"
  )

  # pgagroal.conf.5
  add_custom_command(
    OUTPUT ${PGAGROAL_CONF_DST_FILE}
    COMMAND ${RST2MAN_EXECUTABLE} ${PGAGROAL_CONF_SRC_FILE} ${PGAGROAL_CONF_DST_FILE}
    DEPENDS ${PGAGROAL_CONF_SRC_FILE}
    COMMENT "Generating man page: pgagroal.conf.5"
  )

  # pgagroal_hba.conf.5
  add_custom_command(
    OUTPUT ${PGAGROAL_HBA_CONF_DST_FILE}
    COMMAND ${RST2MAN_EXECUTABLE} ${PGAGROAL_HBA_CONF_SRC_FILE} ${PGAGROAL_HBA_CONF_DST_FILE}
    DEPENDS ${PGAGROAL_HBA_CONF_SRC_FILE}
    COMMENT "Generating man page: pgagroal_hba.conf.5"
  )

  # pgagroal_databases.conf.5
  add_custom_command(
    OUTPUT ${PGAGROAL_DATABASES_CONF_DST_FILE}
    COMMAND ${RST2MAN_EXECUTABLE} ${PGAGROAL_DATABASES_CONF_SRC_FILE} ${PGAGROAL_DATABASES_CONF_DST_FILE}
    DEPENDS ${PGAGROAL_DATABASES_CONF_SRC_FILE}
    COMMENT "Generating man page: pgagroal_databases.conf.5"
  )

  # pgagroal-vault.1
  add_custom_command(
    OUTPUT ${PGAGROAL_VAULT_DST_FILE}
    COMMAND ${RST2MAN_EXECUTABLE} ${PGAGROAL_VAULT_SRC_FILE} ${PGAGROAL_VAULT_DST_FILE}
    DEPENDS ${PGAGROAL_VAULT_SRC_FILE}
    COMMENT "Generating man page: pgagroal-vault.1"
  )

  # pgagroal_vault.conf.5
  add_custom_command(
    OUTPUT ${PGAGROAL_VAULT_CONF_DST_FILE}
    COMMAND ${RST2MAN_EXECUTABLE} ${PGAGROAL_VAULT_CONF_SRC_FILE} ${PGAGROAL_VAULT_CONF_DST_FILE}
    DEPENDS ${PGAGROAL_VAULT_CONF_SRC_FILE}
    COMMENT "Generating man page: pgagroal_vault.conf.5"
  )

  # Group man page outputs into a target
  add_custom_target(manpages ALL
    DEPENDS
    ${PGAGROAL_DST_FILE}
    ${PGAGROAL_CLI_DST_FILE}
    ${PGAGROAL_ADMIN_DST_FILE}
    ${PGAGROAL_VAULT_DST_FILE}
    ${PGAGROAL_CONF_DST_FILE}
    ${PGAGROAL_HBA_CONF_DST_FILE}
    ${PGAGROAL_DATABASES_CONF_DST_FILE}
    ${PGAGROAL_VAULT_CONF_DST_FILE}
  )

  add_dependencies(man manpages)

  #
  # Install configuration and documentation
  #
  install(FILES etc/pgagroal.conf DESTINATION share/doc/pgagroal/etc)
  install(FILES etc/pgagroal_hba.conf DESTINATION share/doc/pgagroal/etc)

  install(DIRECTORY . DESTINATION share/doc/pgagroal FILES_MATCHING PATTERN "*.md" PATTERN "etc" EXCLUDE PATTERN "images" EXCLUDE PATTERN "man" EXCLUDE PATTERN "manual" EXCLUDE)
  install(DIRECTORY images/ DESTINATION share/doc/pgagroal/images FILES_MATCHING PATTERN "*.png")

  install(FILES ${PGAGROAL_DST_FILE} DESTINATION share/man/man1)
  install(FILES ${PGAGROAL_CLI_DST_FILE} DESTINATION share/man/man1)
  install(FILES ${PGAGROAL_ADMIN_DST_FILE} DESTINATION share/man/man1)
  install(FILES ${PGAGROAL_VAULT_DST_FILE} DESTINATION share/man/man1)
  install(FILES ${PGAGROAL_CONF_DST_FILE} DESTINATION share/man/man5)
  install(FILES ${PGAGROAL_HBA_CONF_DST_FILE} DESTINATION share/man/man5)
  install(FILES ${PGAGROAL_DATABASES_CONF_DST_FILE} DESTINATION share/man/man5)
  install(FILES ${PGAGROAL_VAULT_CONF_DST_FILE} DESTINATION share/man/man5)
endif()

#
# Generate manual
#
if (DOCS)
  FILE(GLOB EN "manual/en/??-*.md")

  # Manuals definitions
  set(MANUAL_OUTPUT_DIR "${CMAKE_BINARY_DIR}/doc")
  get_filename_component(PARENT_DIR ${CMAKE_BINARY_DIR} DIRECTORY)
  set(IMAGE_DIR "${PARENT_DIR}/doc/images")

  add_custom_target(
    copy_images
    COMMAND ${CMAKE_COMMAND} -E copy_directory ${IMAGE_DIR} ${CMAKE_BINARY_DIR}/images
    COMMENT "Copy images"
  )

  add_custom_command(
    OUTPUT ${MANUAL_OUTPUT_DIR}/pgagroal-en.pdf
    COMMAND ${PANDOC_EXECUTABLE} -o ${MANUAL_OUTPUT_DIR}/pgagroal-en.pdf --from markdown --template eisvogel --listings -N --toc ${EN}
    DEPENDS ${EN}
    COMMENT "Generating English PDF documentation"
  )

  add_custom_command(
    OUTPUT ${MANUAL_OUTPUT_DIR}/pgagroal-en.html
    COMMAND ${PANDOC_EXECUTABLE} -o ${MANUAL_OUTPUT_DIR}/pgagroal-en.html -s -f markdown-smart -N --toc -t html5 ${EN}
    DEPENDS ${EN}
    COMMENT "Generating English HTML documentation"
  )

  add_custom_target(
    all_docs ALL
    DEPENDS copy_images ${MANUAL_OUTPUT_DIR}/pgagroal-en.pdf ${MANUAL_OUTPUT_DIR}/pgagroal-en.html
  )

  install(FILES ${MANUAL_OUTPUT_DIR}/pgagroal-en.pdf DESTINATION share/doc/pgagroal/manual)
  install(FILES ${MANUAL_OUTPUT_DIR}/pgagroal-en.html DESTINATION share/doc/pgagroal/manual)

  #
  # Generate API docs
  #
  if (DOXYGEN_FOUND)
    add_custom_target(api ALL)

    set(DOXYGEN_GENERATE_HTML YES)
    set(DOXYGEN_GENERATE_MAN NO)
    set(DOXYGEN_WARN_AS_ERROR FAIL_ON_WARNINGS)
    set(DOXYFILE_OUT ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile.doxygen)

    doxygen_add_docs(doxygen ${PROJECT_SOURCE_DIR}/src/include/)

    if (${DOXYGEN_VERSION} STREQUAL "1.10.0" OR
        ${DOXYGEN_VERSION} STREQUAL "1.11.0" OR
        ${DOXYGEN_VERSION} STREQUAL "1.12.0" OR
        ${DOXYGEN_VERSION} STREQUAL "1.13.0" OR
        ${DOXYGEN_VERSION} STREQUAL "1.13.1" OR
        ${DOXYGEN_VERSION} STREQUAL "1.13.2" OR
        ${DOXYGEN_VERSION} STREQUAL "1.14.0" OR
        ${DOXYGEN_VERSION} STREQUAL "1.15.0" OR
        ${DOXYGEN_VERSION} STREQUAL "1.16.0" OR
        ${DOXYGEN_VERSION} STREQUAL "1.16.1")

      add_custom_command(
        TARGET api
        COMMAND ${DOXYGEN_EXECUTABLE} -q ${DOXYFILE_OUT}
        COMMENT "Generating API documentation"
        POST_BUILD
      )
    else()
      add_custom_command(
        TARGET api
        COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYFILE_OUT}
        COMMENT "Generating API documentation"
        POST_BUILD
      )
    endif()
  endif()
endif()

=== src/CMakeLists.txt ===
#
# Add files for libpgagroal
#
FILE(GLOB SOURCE_FILES "libpgagroal/*.c")
FILE(GLOB HEADER_FILES "include/*.h")

set(SOURCES ${SOURCE_FILES} ${HEADER_FILES})

function(pgagroal_require_shared_libs)
  foreach(lib_var IN LISTS ARGN)
    if (NOT DEFINED ${lib_var})
      continue()
    endif()

    set(updated_libs "")
    foreach(lib IN LISTS ${lib_var})
      if (IS_ABSOLUTE "${lib}" AND lib MATCHES "\\.a$")
        get_filename_component(lib_dir "${lib}" DIRECTORY)
        get_filename_component(lib_name "${lib}" NAME_WE)
        string(REGEX REPLACE "^lib" "" lib_base "${lib_name}")
        set(shared_lib "")
        if (${CMAKE_SYSTEM_NAME} STREQUAL "Darwin")
          file(GLOB shared_candidates
            "${lib_dir}/${lib_name}.dylib*"
            "${lib_dir}/${lib_base}.dylib*")
        else()
          file(GLOB shared_candidates
            "${lib_dir}/${lib_name}.so*"
            "${lib_dir}/${lib_base}.so*")
        endif()

        if (shared_candidates)
          list(GET shared_candidates 0 shared_lib)
        endif()

        if (shared_lib)
          list(APPEND updated_libs "${shared_lib}")
        else()
          message(FATAL_ERROR "Static library detected: ${lib}. Shared libraries are required.")
        endif()
      else()
        list(APPEND updated_libs "${lib}")
      endif()
    endforeach()
    set(${lib_var} "${updated_libs}" PARENT_SCOPE)
  endforeach()
endfunction()

#
# OS
#
if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")

  add_compile_options(-DHAVE_LINUX)
  add_compile_options(-D_POSIX_C_SOURCE=200809L)

  #
  # Include directories
  #
  include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}/include
    ${OPENSSL_INCLUDE_DIR}
    ${THREAD_INCLUDE_DIRS}
    ${ZLIB_INCLUDE_DIRS}
    ${BZIP2_INCLUDE_DIRS}
    ${ZSTD_INCLUDE_DIRS}
    ${LZ4_INCLUDE_DIRS}
  )

  #
  # Event library backend
  #
  if (NOT LIBURING_FOUND)
    message(FATAL_ERROR "liburing was not found")
  endif()

  set(IO_URING_CONSTANTS_TEST "
#include <liburing.h>
#ifndef IORING_SETUP_CQSIZE
#error \"IORING_SETUP_CQSIZE missing\"
#endif
#ifndef IORING_SETUP_DEFER_TASKRUN
#error \"IORING_SETUP_DEFER_TASKRUN missing\"
#endif
#ifndef IORING_SETUP_SINGLE_ISSUER
#error \"IORING_SETUP_SINGLE_ISSUER missing\"
#endif
#ifndef IORING_FEAT_FAST_POLL
#error \"IORING_FEAT_FAST_POLL missing\"
#endif
#ifndef IORING_SETUP_NO_MMAP
#error \"IORING_SETUP_NO_MMAP missing\"
#endif
#ifndef IORING_TIMEOUT_MULTISHOT
#error \"IORING_TIMEOUT_MULTISHOT missing\"
#endif
#ifndef IORING_SQ_CQ_OVERFLOW
#error \"IORING_SQ_CQ_OVERFLOW missing\"
#endif
#ifndef IORING_CQE_BUFFER_SHIFT
#error \"IORING_CQE_BUFFER_SHIFT missing\"
#endif
#ifndef IORING_CQE_F_MORE
#error \"IORING_CQE_F_MORE missing\"
#endif
int main(void) { return 0; }
")

  set(CMAKE_REQUIRED_INCLUDES "${LIBURING_INCLUDE_DIRS}")
  check_c_source_compiles("${IO_URING_CONSTANTS_TEST}" HAVE_IO_URING_CONSTANTS)
  set(CMAKE_REQUIRED_INCLUDES "")

  if (HAVE_IO_URING_CONSTANTS)
    add_compile_options(-DHAVE_IO_URING)
    include_directories(${LIBURING_INCLUDE_DIRS})
    set(PGAGROAL_IO_URING_LIBRARIES ${LIBURING_LIBRARY})
  else()
    message(STATUS "io_uring constants missing; disabling io_uring backend")
  endif()

  pgagroal_require_shared_libs(
    OPENSSL_CRYPTO_LIBRARY
    OPENSSL_SSL_LIBRARY
    LIBATOMIC_LIBRARY
    THREAD_LIBRARY
    ZLIB_LIBRARIES
    BZIP2_LIBRARIES
    ZSTD_LIBRARIES
    LZ4_LIBRARIES
    PGAGROAL_IO_URING_LIBRARIES
  )

  #
  # Library directories
  #
  link_libraries(
    ${OPENSSL_CRYPTO_LIBRARY}
    ${OPENSSL_SSL_LIBRARY}
    ${LIBATOMIC_LIBRARY}
    ${THREAD_LIBRARY}
    ${ZLIB_LIBRARIES}
    ${BZIP2_LIBRARIES}
    ${ZSTD_LIBRARIES}
    ${LZ4_LIBRARIES}
    ${PGAGROAL_IO_URING_LIBRARIES}
  )

  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined")
elseif(${CMAKE_SYSTEM_NAME} STREQUAL "Darwin")
  find_program(HOMEBREW_EXECUTABLE brew)
  if(EXISTS ${HOMEBREW_EXECUTABLE})
    execute_process(
      COMMAND ${HOMEBREW_EXECUTABLE} --prefix
      OUTPUT_VARIABLE HOMEBREW_PREFIX
      OUTPUT_STRIP_TRAILING_WHITESPACE)
    message(STATUS "Homebrew found at ${HOMEBREW_PREFIX}")
  endif()

  #
  # Detecting OpenSSL
  #
  execute_process(
    COMMAND ${HOMEBREW_EXECUTABLE} --prefix openssl
    OUTPUT_VARIABLE HOMEBREW_OPENSSL
    OUTPUT_STRIP_TRAILING_WHITESPACE)
  if(DEFINED HOMEBREW_OPENSSL)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -I${HOMEBREW_OPENSSL}/include")
  else()
    message(FATAL_ERROR "Homebrew's OpenSSL needed")
  endif()

  add_compile_options(-D_DARWIN_C_SOURCE)
  add_compile_options(-DHAVE_OSX)

  #
  # Include directories
  #
  include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}/include
    ${OPENSSL_INCLUDE_DIRS}
    ${THREAD_INCLUDE_DIRS}
    ${ZLIB_INCLUDE_DIRS}
    ${BZIP2_INCLUDE_DIRS}
    ${ZSTD_INCLUDE_DIRS}
    ${LZ4_INCLUDE_DIRS}
  )

  pgagroal_require_shared_libs(
    OPENSSL_LIBRARIES
    THREAD_LIBRARY
    ZLIB_LIBRARIES
    BZIP2_LIBRARIES
    ZSTD_LIBRARIES
    LZ4_LIBRARIES
  )

  #
  # Library directories
  #
  link_libraries(
    ${OPENSSL_LIBRARIES}
    ${THREAD_LIBRARY}
    ${ZLIB_LIBRARIES}
    ${BZIP2_LIBRARIES}
    ${ZSTD_LIBRARIES}
    ${LZ4_LIBRARIES}
  )
else()

  add_compile_options(-D_XOPEN_SOURCE=700)
  add_compile_options(-D_BSD_SOURCE)
  add_compile_options(-D_DEFAULT_SOURCE)
  add_compile_options(-D__BSD_VISIBLE)

  if (${CMAKE_SYSTEM_NAME} STREQUAL "OpenBSD")
    add_compile_options(-DHAVE_OPENBSD)
  elseif (${CMAKE_SYSTEM_NAME} STREQUAL "FreeBSD")
     add_compile_options(-DHAVE_FREEBSD)
  endif()

  if (SYSTEMD_FOUND)
  add_compile_options(-DHAVE_SYSTEMD)

  include_directories(${SYSTEMD_INCLUDE_DIRS})
  link_libraries(${SYSTEMD_LIBRARIES})
  endif()

  #
  # Include directories
  #
  include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}/include
    ${OPENSSL_INCLUDE_DIRS}
    ${THREAD_INCLUDE_DIRS}
    ${ZLIB_INCLUDE_DIRS}
    ${BZIP2_INCLUDE_DIRS}
    ${ZSTD_INCLUDE_DIRS}
    ${LZ4_INCLUDE_DIRS}
  )

  pgagroal_require_shared_libs(
    SYSTEMD_LIBRARIES
    OPENSSL_LIBRARIES
    THREAD_LIBRARY
    ZLIB_LIBRARIES
    BZIP2_LIBRARIES
    ZSTD_LIBRARIES
    LZ4_LIBRARIES
  )

  #
  # Library directories
  #
  link_libraries(
    ${OPENSSL_LIBRARIES}
    ${THREAD_LIBRARY}
    ${ZLIB_LIBRARIES}
    ${BZIP2_LIBRARIES}
    ${ZSTD_LIBRARIES}
    ${LZ4_LIBRARIES}
  )
endif()

#
# Compile options
#
add_compile_options(-g)
add_compile_options(-Wall)
add_compile_options(-Werror)
add_compile_options(-std=c17)
add_compile_options(-D__USE_ISOC11)
add_compile_options(-D_GNU_SOURCE)
add_compile_options(-Wno-deprecated)
add_compile_options(-Wno-deprecated-declarations)

#
# version number and string management
#
add_compile_options(-DPGAGROAL_MAJOR_VERSION=${VERSION_MAJOR})
add_compile_options(-DPGAGROAL_MINOR_VERSION=${VERSION_MINOR})
add_compile_options(-DPGAGROAL_PATCH_VERSION=${VERSION_PATCH})
add_compile_options(-DPGAGROAL_VERSION="${VERSION_STRING}")

if(CMAKE_C_COMPILER_ID STREQUAL "GNU")
  add_compile_options(-Wstrict-prototypes)
endif()

check_c_compiler_flag(-fPIC HAS_PIC)
if (HAS_PIC)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC")
endif()

check_include_file(execinfo.h HAVE_EXECINFO_H)
if (HAVE_EXECINFO_H)
  add_compile_options(-DHAVE_EXECINFO_H)
endif()

if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
  include(CheckPIESupported)
  check_pie_supported()
endif()

if (CMAKE_BUILD_TYPE MATCHES Debug)
  add_compile_options(-O0)
  add_compile_options(-DDEBUG)

  check_c_compiler_flag(-Wformat HAS_FORMAT)
  if (HAS_FORMAT)
    set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -Wformat")
  endif()

  check_c_compiler_flag(-Wformat-security HAS_FORMAT_SECURITY)
  if (HAS_FORMAT_SECURITY)
    set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -Wformat-security")
  endif()

  check_c_compiler_flag(-fstack-protector-strong HAS_STACK_PROTECTOR_STRONG)
  if (HAS_STACK_PROTECTOR_STRONG)
    set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -fstack-protector-strong")
  endif()

  check_c_compiler_flag(-rdynamic HAS_DYNAMIC)
  if (HAS_DYNAMIC)
    set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -rdynamic")
    set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -rdynamic")
  endif()

  check_c_compiler_flag(-fstack-protector-strong HAS_STACKPROTECTOR_STRONG)
  if (HAS_STACKPROTECTOR_STRONG)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector-strong")
  else()
    check_c_compiler_flag(-fstack-protector HAS_STACKPROTECTOR)
    if (HAS_STACKPROTECTOR)
      set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector")
    endif()
  endif()

  check_c_compiler_flag(-Wl,arg HAS_LINKER)
  check_linker_flag(C "-z relro" LINKER_HAS_RELRO)
  if (HAS_LINKER AND LINKER_HAS_RELRO)
    set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-z,relro")
    set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-z,relro")
  endif()

  check_linker_flag(C "-z now" LINKER_HAS_NOW)
  if (HAS_LINKER AND LINKER_HAS_NOW)
    set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-z,now")
    set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-z,now")
  endif()

  if(CMAKE_C_COMPILER_ID STREQUAL "Clang")
    add_compile_options(-fprofile-instr-generate)
    add_compile_options(-fcoverage-mapping)
    add_link_options(-fprofile-instr-generate)
    if (NOT ${CMAKE_SYSTEM_NAME} STREQUAL "OpenBSD")
      if (NOT ${CMAKE_SYSTEM_PROCESSOR} STREQUAL "aarch64")
        if (CMAKE_C_COMPILER_VERSION VERSION_GREATER_EQUAL 3.2)
          add_compile_options(-fsanitize=address)
          add_compile_options(-fno-sanitize=null)
          
          if (CMAKE_C_COMPILER_VERSION VERSION_GREATER_EQUAL 3.3)
            add_compile_options(-fsanitize=undefined)
            add_compile_options(-fsanitize=float-divide-by-zero)
            add_compile_options(-fsanitize=float-cast-overflow)
          endif()
          
          if (CMAKE_C_COMPILER_VERSION VERSION_GREATER_EQUAL 3.6)
            add_compile_options(-fno-sanitize-recover=all)
          endif()
          
          if (CMAKE_C_COMPILER_VERSION VERSION_GREATER_EQUAL 3.8)
            add_compile_options(-fsanitize-recover=address)
          endif()
          
          if (CMAKE_C_COMPILER_VERSION VERSION_GREATER_EQUAL 3.9)
            add_compile_options(-fsanitize-address-use-after-scope)
          endif()
          
          add_compile_options(-fno-sanitize=alignment)

          set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_LINKER_FLAGS_DEBUG} -fsanitize=address -fsanitize=undefined -fno-sanitize-recover=all -fsanitize=float-divide-by-zero -fsanitize=float-cast-overflow -fno-sanitize=null -fno-sanitize=alignment")
          set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS_DEBUG} -fsanitize=address -fsanitize=undefined -fno-sanitize-recover=all -fsanitize=float-divide-by-zero -fsanitize=float-cast-overflow -fno-sanitize=null -fno-sanitize=alignment")        
        endif()
      endif()
    endif()
  elseif(CMAKE_C_COMPILER_ID STREQUAL "GNU")
    add_compile_options(--coverage -O0 -g)
    add_link_options(--coverage)
    if (NOT ${CMAKE_SYSTEM_NAME} STREQUAL "OpenBSD")
      if (NOT ${CMAKE_SYSTEM_PROCESSOR} STREQUAL "aarch64")
        if (CMAKE_C_COMPILER_VERSION VERSION_GREATER_EQUAL 4.8)
          add_compile_options(-fsanitize=address)
          
          set(TEMP_EXE_LINKER_FLAGS "-fsanitize=address")
          set(TEMP_SHARED_LINKER_FLAGS "-fsanitize=address")
          
          if (CMAKE_C_COMPILER_VERSION VERSION_GREATER_EQUAL 4.9)
            add_compile_options(-fsanitize=undefined)
            set(TEMP_EXE_LINKER_FLAGS "${TEMP_EXE_LINKER_FLAGS} -fsanitize=undefined")
            set(TEMP_SHARED_LINKER_FLAGS "${TEMP_SHARED_LINKER_FLAGS} -fsanitize=undefined")
          endif()
          
          if (CMAKE_C_COMPILER_VERSION VERSION_GREATER_EQUAL 5.1)
            add_compile_options(-fno-sanitize=alignment)
            add_compile_options(-fno-sanitize-recover=all)
            add_compile_options(-fsanitize=float-cast-overflow)
            add_compile_options(-fsanitize=float-divide-by-zero)

=== test/CMakeLists.txt ===
if (check)

  file(GLOB_RECURSE TEST_SOURCES
    "libpgagroaltest/*.c"
    "testcases/*.c")
  file(GLOB_RECURSE TEST_HEADERS
    "${CMAKE_CURRENT_SOURCE_DIR}/include/*.h")

  set(SOURCES ${TEST_SOURCES} ${TEST_HEADERS})

  if (CMAKE_BUILD_TYPE MATCHES Debug)
    add_compile_options(-O0)
    add_compile_options(-DDEBUG)
  endif()

  if(CMAKE_C_COMPILER_ID STREQUAL "Clang")
    if (NOT ${CMAKE_SYSTEM_NAME} STREQUAL "OpenBSD")
      if (NOT ${CMAKE_SYSTEM_PROCESSOR} STREQUAL "aarch64")
        if (CMAKE_C_COMPILER_VERSION VERSION_GREATER_EQUAL 3.2)
          add_compile_options(-fsanitize=address)
          add_compile_options(-fno-sanitize=null)
          
          if (CMAKE_C_COMPILER_VERSION VERSION_GREATER_EQUAL 3.3)
            add_compile_options(-fsanitize=undefined)
            add_compile_options(-fsanitize=float-divide-by-zero)
            add_compile_options(-fsanitize=float-cast-overflow)
          endif()
          
          if (CMAKE_C_COMPILER_VERSION VERSION_GREATER_EQUAL 3.6)
            add_compile_options(-fno-sanitize-recover=all)
          endif()
          
          if (CMAKE_C_COMPILER_VERSION VERSION_GREATER_EQUAL 3.8)
            add_compile_options(-fsanitize-recover=address)
          endif()
          
          if (CMAKE_C_COMPILER_VERSION VERSION_GREATER_EQUAL 3.9)
            add_compile_options(-fsanitize-address-use-after-scope)
          endif()
          
          add_compile_options(-fno-sanitize=alignment)

          set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_LINKER_FLAGS_DEBUG} -fsanitize=address -fsanitize=undefined -fno-sanitize-recover=all -fsanitize=float-divide-by-zero -fsanitize=float-cast-overflow -fno-sanitize=null -fno-sanitize=alignment")
          set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS_DEBUG} -fsanitize=address -fsanitize=undefined -fno-sanitize-recover=all -fsanitize=float-divide-by-zero -fsanitize=float-cast-overflow -fno-sanitize=null -fno-sanitize=alignment")        
        endif()
      endif()
    endif()
  elseif(CMAKE_C_COMPILER_ID STREQUAL "GNU")
    if (NOT ${CMAKE_SYSTEM_NAME} STREQUAL "OpenBSD")
      if (NOT ${CMAKE_SYSTEM_PROCESSOR} STREQUAL "aarch64")
        if (CMAKE_C_COMPILER_VERSION VERSION_GREATER_EQUAL 4.8)
          add_compile_options(-fsanitize=address)
          
          set(TEMP_EXE_LINKER_FLAGS "-fsanitize=address")
          set(TEMP_SHARED_LINKER_FLAGS "-fsanitize=address")
          
          if (CMAKE_C_COMPILER_VERSION VERSION_GREATER_EQUAL 4.9)
            add_compile_options(-fsanitize=undefined)
            set(TEMP_EXE_LINKER_FLAGS "${TEMP_EXE_LINKER_FLAGS} -fsanitize=undefined")
            set(TEMP_SHARED_LINKER_FLAGS "${TEMP_SHARED_LINKER_FLAGS} -fsanitize=undefined")
          endif()
          
          if (CMAKE_C_COMPILER_VERSION VERSION_GREATER_EQUAL 5.1)
            add_compile_options(-fno-sanitize=alignment)
            add_compile_options(-fno-sanitize-recover=all)
            add_compile_options(-fsanitize=float-cast-overflow)
            add_compile_options(-fsanitize=float-divide-by-zero)
            
            set(TEMP_EXE_LINKER_FLAGS "${TEMP_EXE_LINKER_FLAGS} -fno-sanitize=alignment -fno-sanitize-recover=all -fsanitize=float-cast-overflow -fsanitize=float-divide-by-zero")
            set(TEMP_SHARED_LINKER_FLAGS "${TEMP_SHARED_LINKER_FLAGS} -fno-sanitize=alignment -fno-sanitize-recover=all -fsanitize=float-cast-overflow -fsanitize=float-divide-by-zero")
          endif()
          
          if (CMAKE_C_COMPILER_VERSION VERSION_GREATER_EQUAL 6.0)
            add_compile_options(-fsanitize-recover=address)
            set(TEMP_EXE_LINKER_FLAGS "${TEMP_EXE_LINKER_FLAGS} -fsanitize-recover=address")
            set(TEMP_SHARED_LINKER_FLAGS "${TEMP_SHARED_LINKER_FLAGS} -fsanitize-recover=address")
          endif()
          
          if (CMAKE_C_COMPILER_VERSION VERSION_GREATER_EQUAL 7.0)
            add_compile_options(-fsanitize-address-use-after-scope)
            set(TEMP_EXE_LINKER_FLAGS "${TEMP_EXE_LINKER_FLAGS} -fsanitize-address-use-after-scope")
            set(TEMP_SHARED_LINKER_FLAGS "${TEMP_SHARED_LINKER_FLAGS} -fsanitize-address-use-after-scope")
          endif()
          
          set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${TEMP_EXE_LINKER_FLAGS}")
          set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${TEMP_SHARED_LINKER_FLAGS}")
        endif()
      endif()
    endif()
  endif()

  add_executable(pgagroal_test runner.c ${SOURCES})
  target_include_directories(pgagroal_test PRIVATE ${CMAKE_SOURCE_DIR}/src/include ${CMAKE_SOURCE_DIR}/test/include)

  if(EXISTS "/etc/debian_version")
    target_link_libraries(pgagroal_test Check::check subunit pthread rt m pgagroal)
  elseif(APPLE)
    target_link_libraries(pgagroal_test Check::check m pgagroal)
  else()
    target_link_libraries(pgagroal_test Check::check pthread rt m pgagroal)
  endif()

  add_custom_target(custom_clean
    COMMAND ${CMAKE_COMMAND} -E remove -f *.o pgagroal_test
    COMMENT "Cleaning up..."
  )
endif()

if(container)

add_test(NAME container_test
           COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/check.sh
           WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

set_property(TEST container_test
             PROPERTY FAIL_REGULAR_EXPRESSION "Failures: [1-9][0-9]*")

endif()

file(
    COPY
    "${CMAKE_SOURCE_DIR}/test/conf"
    DESTINATION "${CMAKE_BINARY_DIR}/"
)
configure_file(
  "${CMAKE_SOURCE_DIR}/test/check.sh"
  "${CMAKE_BINARY_DIR}/check.sh"
  COPYONLY
)

=== test/postgresql/src/postgresql17/Makefile ===
# Makefile for pgagroal PostgreSQL 17 test container

IMAGE_NAME = pgagroal-test-postgresql17-rocky9
CONTAINER_NAME = pgagroal-test-postgresql17

# Detect container engine
CONTAINER_ENGINE := $(shell \
	if command -v podman >/dev/null 2>&1; then echo podman; \
	elif command -v docker >/dev/null 2>&1; then echo "sudo docker"; \
	else echo "Neither Docker nor Podman is installed" >&2; exit 1; \
	fi)

.PHONY: all build clean run stop

all: build

build:
	@echo "Building PostgreSQL 17 container image: $(IMAGE_NAME)"
	$(CONTAINER_ENGINE) build -t $(IMAGE_NAME) -f Dockerfile .

clean:
	@echo "Cleaning PostgreSQL 17 container image: $(IMAGE_NAME)"
	$(CONTAINER_ENGINE) rmi $(IMAGE_NAME) 2>/dev/null || true

run:
	@echo "Running PostgreSQL 17 container: $(CONTAINER_NAME)"
	$(CONTAINER_ENGINE) run -p 5432:5432 --name $(CONTAINER_NAME) -d \
		-e PG_DATABASE=mydb \
		-e PG_USER_NAME=myuser \
		-e PG_USER_PASSWORD=password \
		-e PG_REPL_USER_NAME=repl \
		-e PG_REPL_PASSWORD=password \
		-e PG_LOG_LEVEL=debug5 \
		$(IMAGE_NAME)

stop:
	@echo "Stopping PostgreSQL 17 container: $(CONTAINER_NAME)"
	$(CONTAINER_ENGINE) stop $(CONTAINER_NAME) 2>/dev/null || true
	$(CONTAINER_ENGINE) rm -f $(CONTAINER_NAME) 2>/dev/null || true

=== debian/changelog ===
pgagroal (2.0.1-2) unstable; urgency=medium

  * debian/tests/connect: Test pgagroal.service for now, .socket has problems.

 -- Christoph Berg <myon@debian.org>  Mon, 23 Feb 2026 13:47:41 +0100

pgagroal (2.0.1-1) unstable; urgency=medium

  * New upstream version 2.0.1.
  * debian/tests/connect: Use system PG cluster for tests.

 -- Christoph Berg <myon@debian.org>  Wed, 18 Feb 2026 14:25:00 +0100

pgagroal (2.0.0-3) unstable; urgency=medium

  * Unsupport 32-bit architectures. (Closes: #1127845,
    https://github.com/pgagroal/pgagroal/issues/718)

 -- Christoph Berg <myon@debian.org>  Tue, 17 Feb 2026 11:54:36 +0100

pgagroal (2.0.0-2) unstable; urgency=medium

  * Link libraries dynamically.

 -- Christoph Berg <myon@debian.org>  Fri, 13 Feb 2026 19:00:33 +0100

=== debian/control ===
Source: pgagroal
Section: database
Priority: optional
Maintainer: Debian PostgreSQL Maintainers <team+postgresql@tracker.debian.org>
Uploaders:
 Christoph Berg <myon@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 architecture-is-64-bit,
 cmake (>= 3.14.0),
 libbz2-dev,
 libcjson-dev,
 libev-dev,
 liblz4-dev,
 libssl-dev,
 libsystemd-dev,
 liburing-dev,
 libzstd-dev,
 postgresql-all,
 python3-docutils,
 zlib1g-dev,
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://github.com/agroal/pgagroal
Vcs-Browser: https://salsa.debian.org/postgresql/pgagroal
Vcs-Git: https://salsa.debian.org/postgresql/pgagroal.git

Package: pgagroal
Architecture: any
Depends:
 postgresql-common,
 ${misc:Depends},
 ${shlibs:Depends},
Description: High-performance connection pool for PostgreSQL
 pgagroal is a high-performance protocol-native connection pool for PostgreSQL.
 .
 Pronounced: p-g-a-gro-al, named after Agroal in Portugal.
 .
 Features:
  * High performance
  * Connection pool
  * Limit connections for users and databases
  * Prefill support
  * Remove idle connections
  * Perform connection validation
  * Enable / disable database access
  * Graceful / fast shutdown
  * Prometheus support
  * Grafana 8 dashboard
  * Remote management
  * Authentication query support
  * Failover support
  * Transport Layer Security (TLS) v1.2+ support
  * Daemon mode
  * User vault

=== debian/tests/control ===
Depends:
 postgresql,
 procps,
 @,
Tests:
 connect,
Restrictions:
 allow-stderr,
 needs-root,
